import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkSignupLists, ThinkSignupListsParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkSignupLists(params: ThinkSignupListsParam) {
  const res = await request.get<ApiResult<PageResult<ThinkSignupLists>>>(
    THINK_API_URL + '/think/think-signup-lists/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkSignupLists(params?: ThinkSignupListsParam) {
  const res = await request.get<ApiResult<ThinkSignupLists[]>>(
    THINK_API_URL + '/think/think-signup-lists',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkSignupLists(data: ThinkSignupLists) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-signup-lists',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkSignupLists(data: ThinkSignupLists) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-signup-lists',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkSignupLists(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-signup-lists/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkSignupLists(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-signup-lists/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkSignupLists(id: number) {
  const res = await request.get<ApiResult<ThinkSignupLists>>(
    THINK_API_URL + '/think/think-signup-lists/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
